#!/usr/bin/perl -w

my ($y,$host,$page,$rem);

use IO::Socket;

$okchars = '-a-zA-Z0-9.,:@#%&*\-_=+?\/\'\ ';
$host = shift || usage();
$page = shift || usage();
$lines = shift || undef;
$page =~ s/ /\+/g;
$page =~ s/%([\da-f]{1,2})/pack(C,hex($1))/eig;

@li = calc_lines( $lines );
if ($y) {
	$y =~ s/[^$okchars]//go;
}
if ($host) {
	$host =~ s/[^$okchars]//go;
}
if ($page) {
	$page =~ s/[^$okchars]//go;
}
if ($lines) {
	$lines =~ s/[^$okchars]//go;
}
if ($rem) {
	$rem =~ s/[^$okchars]//go;
}

#$rem = IO::Socket::INET->new( "$host:80" ) || die($!);
$rem = IO::Socket::INET->new( "$host:80" ) || do { print "<b>Unable to query please try again or reload.\n"; exit( 0 ); };
$rem->autoflush( 1 );

print $rem "GET $page HTTP/1.0\nUser-Agent: Lynx/2.6  libwww-FM/2.14\n\n";

while( <$rem> ) {
	chomp;
	last if( $_ =~ /^\s{0,}$/ );
}

$y = 0;
while( <$rem> ) {
	chomp;

	#s/<.*?>//g;
	#next if( /^\s{0,}$/ );

	# s/(,\d{3})\s.*?$/$1/;
	#s/(\d+)\s+\w+,\s\w+,/$1/g;

	# s/(\(\w+:.*?\)).*?$/$1/g;
	s/\s+$//g;
	s/^\s+//;
	s/<center>//g;
	s/<\/center>//g;
	s/<CENTER>//g;
	s/<\/CENTER>//g;
	s/<td>//g;
	s/<\/td>//g;
	s/<tr>//g;
	s/<\/tr>//g;
	s/<TD>//g;
	s/<\/TD>//g;
	s/<TR>//g;
	s/<\/TR>//g;
	s/<\/table>//g;
	s/<\/TABLE>//g;
	s/<dl>//g;
	s/<dt>//g;
	s/<li>//g;
	s/<LI>//g;
	s/<ul>//g;
	s/<UL>//g;
	s/<UL TYPE=disc>//g;
	s/<\/ul>//g;
	s/<\/UL>//g;
	s/<A HREF/<li><A HREF/g;
	s/<dd>//g;
	s/<b>//g;
	s/<\/b>//g;

	$out[$y] = $_;
	$y++;
}

for( $y = 0; $y < @out; $y++ ) {
	if( $li[0] != 0 ) {
		foreach $n (@li) {
			if( $y == $n ) {
				print $out[$y] . "\n";
			}
		}
	}
	else {
		print $out[$y] . "\n";
	}
}

sub calc_lines {
	my (@tmp,$i);
	my ($narf) = @_;

	$i = 0;

	if( ! defined( $narf ) ) {
		return 0;
	}

	if( $narf =~ /,/ ) {
		foreach $n (split(/,/, $narf)) {
			$tmp[$i] = $n;
			$i++;
		}
	}
	else {
		@tmp = $narf;
	}

	for( $i = 0; $i < @tmp; $i++ ) {
		if( $tmp[$i] =~ /^(\d+)-(\d+)$/ ) {
			($t1,$t2) = ($1,$2);
			if( $t2 > $t1 ) {
				$tmp[$i] = $t1;
				for( ($t1+1) .. $t2 ) {
					$tmp[@tmp] = $_;
				}
			}
			else {
				die( "Invalid range in line specs\n" );
			}
		}
	}
	return (@tmp);
}
