#!/usr/bin/perl -w
#
# SiteAdd for SiteFeeder PRO by Damon Pike (piker@nethog.com)";
#
require ".sitefeeder";

$okchars = '-a-zA-Z0-9.,:@#%&*\-_=+?\/\'\ ';

# Read input variables
sub ReadParse {
  if (@_) {
    local (*in) = @_;
  }

  local ($i, $loc, $key, $val);

  # Read in text
  if ($ENV{'REQUEST_METHOD'} eq "HEAD") {
    $in = $ENV{'QUERY_STRING'};
	$in =~ s/[^$okchars]//go;
  }
  if ($ENV{'REQUEST_METHOD'} eq "GET") {
    $in = $ENV{'QUERY_STRING'};
	$in =~ s/[^$okchars]//go;
  } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
    for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
      $in .= getc;
	$in =~ s/[^$okchars]//go;
    }
  }

  @in = split(/&/,$in);

  foreach $i (0 .. $#in) {
    # Convert plus's to spaces
    $in[$i] =~ s/\+/ /g;

    # Convert %XX from hex numbers to alphanumeric
    $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
	$in[$i] =~ s/[^$okchars]//go;

    # Split into key and value.
    $loc = index($in[$i],"=");
    $key = substr($in[$i],0,$loc);
    $val = substr($in[$i],$loc+1);
    $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
    $in{$key} .= $val;
  }

  return 1; # just for fun
}
&ReadParse();


$url = $in{"the_url"};
$title = $in{"the_title"};
$desc = $in{"the_desc"};
$words = $in{"the_words"};
$email = $in{"email"};
$url =~ s/\{|\}|\(|\)|'|\|\$|\\|;|\"|`//g;  # strip hacking characters
$title =~ s/\{|\}|\(|\)|'|\|\$|\\|;|\"|`//g;  # strip hacking characters
$desc =~ s/\{|\}|\(|\)|'|\|\$|\\|;|\"|`//g;  # strip hacking characters
$words =~ s/\{|\}|\(|\)|'|\|\$|\\|;|\"|`//g;  # strip hacking characters
$email =~ s/\{|\}|\(|\)|'|\|\$|\\|;|\"|`//g;  # strip hacking characters

if ($url eq "") {&error()}
if ($title eq "") {&error()}
if ($desc eq "") {&error()}
if ($words eq "") {&error()}
if ($email eq "") {&error()}
else {
&add()
}

sub error {
print "Content-type: text/html\n\n";
print "<HTML>";
print "<HEAD><TITLE>$sitename Newsites: Add Error</TITLE></HEAD>";
print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\">";
print "<CENTER><H1>Oops! You need to fill in more info!</H1><br>Your forgot one or more fields to fill in. <b>&lt;&lt;<a href=\"#\" onclick=\"history.go(-1)\">Go Back</a></b> and try again.<br>\n";
print "</center>";
print "</BODY>";
print "</HTML>";
exit;
}

sub add {
open(EMAILDB,">>$htmldir/newsites.db");
print EMAILDB "$title;$url;$desc;$words;$email\n";
open(SUGGESTION_DB,">>$htmldir/newsites.hog");
print SUGGESTION_DB "<a href=\"$url\">$title</a>";
print SUGGESTION_DB " - $desc \(";

$email =~ s/\@/ at /g;
print SUGGESTION_DB "$words -submitted by <a href=\"mailto:$email\">$email</a>\)<br><br>";
print SUGGESTION_DB "\n";

print "Content-type: text/html\n\n";
print "<HTML>";
print "<HEAD><TITLE>$sitename Newsites: Site Added</TITLE></HEAD>";
print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\">";

print "<CENTER><H1>Thanks for your addition!</H1><br><a href=\"$url\">Your site: <b>$title</b></a> will be reviewed for addition soon! Meanwhile it will be seen <a href=\"/?feed=$words\">here</a>.<br\n";
print "</center>";
print "<b>&lt;&lt;<a href=\"#\" onclick=\"history.go(-2)\">Back to site</a></b><br>";
print "<b>&lt;&lt;<a href=\"#\" onclick=\"history.go(-1)\">Back to new sites page</a></b><br>";
print "</BODY>";
print "</HTML>";
close(EMAILDB);
close(SUGGESTION_DB);
exit;
}
